(*****************************************************************************)
(*									     *)
(*                    UniPascal Librarian. version 1.55                      *)
(*		       (c)1989, 92 George Petrov /YGP/			     *)
(*									     *)
(*  Usage: UPL FileName {option UnitName} [@]				     *)
(*									     *)
(*  options:   + adds a unit						     *)
(*	       - deletes a unit 					     *)
(*	       * extracts a unit					     *)
(*	       ?[m,s,i] lists a unit					     *)
(*	       /[m,s,i] same as above                                        *)
(*									     *)
(*  Specify @ to fetch special information (SRDL info only)		     *)
(*									     *)
(*****************************************************************************)

{$define SRDLinfo}

program UPL(input, output);					       {$I-,R-}
  (*) uses inlines; {*) uses UniPascal, BIOS_CRT; {*}

  var NormalExit: boolean;						 (*){*)
      ExitSave:    pointer;						    {*}

  {$I	 globals.upl }				{ global types and variables. }

  procedure ListMod(wr_int_segs: boolean;
                    (*)const(*) MD: ModDescriptor; var f: file;
		    (*)const(*) FName: string); 		       forward;

  {$I	  miscpf.upl }				  { miscellaneous proc/funcs. }
  {$I	 extract.upl }				   { process extract command. }
  {$I	  remove.upl }				    { process remove command. }
  {$I	    list.upl }				      { process list command. }
  {$I	     add.upl }				       { process add command. }
  {$I	    copy.upl }					  { copy all modules. }
  {$I initialize.upl }				      { initialize librarian. }
  {$I	FinishUp.upl }					{ finishup librarian. }

									 (*){*)
  label exit;								    {*}

begin { UPL }								 (*){*)
  ExitSave:= ExitProc; ExitProc:= @FinishUp;                                {*}

  {	      temporary  (    }
  {  )           library.    }

  SRDL:= false; NormalExit:= false;
  Initialize;
  repeat
    case rq^.option of

      list_MOD: begin
	listOps:= byte(rq^.name[1]); delete(rq^.name, 1, 1);
	DoList(rq^.name);
      end { when list };

      add_MOD: begin
	DoAdd(rq^.name);
      end { when add };

      remove_MOD: begin
	DoRemove(rq^.name);
      end { when remove };

      extract_MOD: begin
	DoExtract(rq^.name);
      end { when extract };

    end { case };
    rq:= rq^.next;
  until rq = nil;

  CopyAllMods;

  NormalExit:= true;

exit:

  FinishUp;
end { UPL }.